ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/deliantra/server/utils/cfutil.in
(Generate patch)

Comparing deliantra/server/utils/cfutil.in (file contents):
Revision 1.4 by root, Wed Mar 7 20:30:18 2007 UTC vs.
Revision 1.45 by root, Tue Jul 24 22:49:41 2007 UTC

6my $exec_prefix = "@exec_prefix@"; 6my $exec_prefix = "@exec_prefix@";
7my $datarootdir = "@datarootdir@"; 7my $datarootdir = "@datarootdir@";
8my $DATADIR = "@datadir@/@PACKAGE@"; 8my $DATADIR = "@datadir@/@PACKAGE@";
9 9
10my $CONVERT = "@CONVERT@"; 10my $CONVERT = "@CONVERT@";
11my $IDENTIFY = "@IDENTIFY@"; 11#my $IDENTIFY = "@IDENTIFY@";
12my $OPTIPNG = "@OPTIPNG@"; 12my $OPTIPNG = "@OPTIPNG@";
13my $RSYNC = "@RSYNC@"; 13my $RSYNC = "@RSYNC@";
14my $PNGNQ = "@PNGNQ@";
14 15
15use Getopt::Long; 16use Getopt::Long;
16use Coro::Event; 17use Coro::Event;
17use AnyEvent; 18use AnyEvent;
18use IO::AIO (); 19use IO::AIO ();
19use File::Temp; 20use File::Temp;
20use Crossfire; 21use Crossfire;
21use Coro; 22use Coro;
22use Coro::AIO; 23use Coro::AIO;
23use POSIX (); 24use POSIX ();
25use Digest::MD5;
26use Carp;
27use Coro::Storable; $Storable::canonical = 1;
28
29$SIG{QUIT} = sub { Carp::cluck "QUIT" };
24 30
25sub usage { 31sub usage {
26 warn <<EOF; 32 warn <<EOF;
27Usage: cfutil [-v] [-q] [--force] [--cache] 33Usage: cfutil [-v] [-q] [--force] [--cache]
28 [--install-arch path] 34 [--install-arch path]
40my $CACHE = 0; 46my $CACHE = 0;
41my $FORCE; 47my $FORCE;
42my $TMPDIR = "/tmp/cfutil$$~"; 48my $TMPDIR = "/tmp/cfutil$$~";
43my $TMPFILE = "aaaa0"; 49my $TMPFILE = "aaaa0";
44 50
51our %COLOR = (
52 black => 0,
53 white => 1,
54 navy => 2,
55 red => 3,
56 orange => 4,
57 blue => 5,
58 darkorange => 6,
59 green => 7,
60 lightgreen => 8,
61 grey => 9,
62 brown => 10,
63 gold => 11,
64 tan => 12,
65);
66
45END { system "rm", "-rf", $TMPDIR } 67END { system "rm", "-rf", $TMPDIR }
46 68
47Event->signal (signal => "INT", cb => sub { exit 1 }); 69Event->signal (signal => "INT", cb => sub { exit 1 });
48Event->signal (signal => "TERM", cb => sub { exit 1 }); 70Event->signal (signal => "TERM", cb => sub { exit 1 });
49 71
66} 88}
67 89
68sub inst_maps($) { 90sub inst_maps($) {
69 my (undef, $path) = @_; 91 my (undef, $path) = @_;
70 92
71 print "installing '$path' to '$DATADIR/maps'\n\n"; 93 print "\nInstalling '$path' to '$DATADIR/maps'\n\n";
72 94
73 if (!-f "$path/regions") { 95 if (!-f "$path/regions") {
74 warn "'$path' does not look like a maps directory ('regions' file is missing).\n"; 96 warn "'$path' does not look like a maps directory ('regions' file is missing).\n";
75 exit 1 unless $FORCE; 97 exit 1 unless $FORCE;
76 } 98 }
77 99
78 system $RSYNC, "-av", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded"; 100 system $RSYNC, "-a", "--chmod=u=rwX,go=rX", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded"
101 and die "map installation failed.\n";
102
103 print "maps installed successfully.\n";
79} 104}
80 105
81{ 106{
82 our @PNG; 107 our %ANIMINFO;
108 our %FACEINFO;
109 our %RESOURCE;
83 our @ARC; 110 our @ARC;
111 our %ARC;
112 our $TRS;
84 our $NFILE; 113 our $NFILE;
114 our $PATH;
85 115
116 our $QUANTIZE = "+dither -colorspace RGB -colors 256";
117
86 our (@png, @trs, @arc); # files we are interested in 118 our (@png, @trs, @arc, @res); # files we are interested in
87 119
88 sub commit_png { 120 sub commit_png($$$) {
89 my ($name, $data) = @_; 121 my ($name, $data, $T) = @_;
90 #warn "$name: commited\n"; 122
123 $FACEINFO{$name}{"data$T"} = $data;
91 } 124 }
92 125
93 sub process_png { 126 sub process_png {
94 while (@png) { 127 while (@png) {
95 my $path = pop @png; 128 my ($path, $delete) = @{pop @png};
96 129
97 my $png; 130 my $png;
98 aio_lstat $path; 131 aio_lstat $path;
99 my ($size, $mtime) = (stat _)[7,9]; 132 my ($size, $mtime) = (stat _)[7,9];
100 133
101 if (0 > aio_load $path, $png) { 134 if (0 > aio_load $path, $png) {
102 warn "$path: $!, skipping.\n"; 135 warn "$path: $!, skipping.\n";
103 return; 136 next;
104 } 137 }
105 138
139 my $stem = $path;
140 my $T;
141
142 if ($stem =~ s/\.32x32\.png~?$//) {
143 $T = 32;
144 } elsif ($stem =~ s/\.64x64\.png~?$//) {
145 $T = 64;
146 } else {
147 warn "$path: weird filename, skipping.\n";
148 next;
149 }
150
106 # quickly extratc width and height of the (necessarily PNG) image 151 # quickly extract width and height of the (necessarily PNG) image
107 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) { 152 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) {
108 warn "$path: not a recongized png file, skipping.\n"; 153 warn "$path: not a recognized png file, skipping.\n";
109 return; 154 next;
110 } 155 }
111 156
112 my ($w, $h) = unpack "NN", $1; 157 my ($w, $h) = unpack "NN", $1;
113
114 (my $face = $path) =~ s/^.*\///;
115 my $T = 32;
116
117 unless ($face =~ s/\.base\.(...)\.png$/.$1/) {
118 warn "$path: weird filename, skipping.\n";
119 return;
120 }
121 158
122 if ($w < $T || $h < $T) { 159 if ($w < $T || $h < $T) {
123 warn "$path: too small ($w $h), skipping.\n"; 160 warn "$path: too small ($w $h), skipping.\n";
124 return; 161 next;
125 } 162 }
126 163
127 if ($w % $T || $h % $T) { 164 if ($w % $T || $h % $T) {
128 warn "$path: weird png size ($w $h), skipping.\n"; 165 warn "$path: weird png size ($w $h), skipping.\n";
129 return; 166 next;
167 }
168
169 unless ($path =~ /~$/) {
170 # possibly enlarge
171 if (0 > aio_stat "$stem.64x64.png") {
172 my $other = "$stem.64x64.png~";
173
174 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
175 my $wrap = 0; # for the time being
176 fork_sub {
177 system "convert png:\Q$path\E -depth 8 rgba:-"
178 . "| $exec_prefix/bin/cfhq2xa $w $h $wrap"
179 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $QUANTIZE -quality 00 png32:\Q$other\E~"
180 and die "convert/hq2xa pipeline error: status $? ($!)";
181 system $OPTIPNG, "-i0", "-q", "$other~";
182 die "$other~ has zero size, aborting." unless -s "$other~";
183 rename "$other~", $other;
184 };
185 }
186
187 push @png, [$other, !$CACHE];
130 } 188 }
131 189
190 # possibly scale down
191 if (0 > aio_stat "$stem.32x32.png") {
192 my $other = "$stem.32x32.png~";
193
194 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
195 fork_sub {
196 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~";
197 system $OPTIPNG, "-i0", "-q", "$other~";
198
199 # reduce smoothfaces >10000 bytes
200 if ($stem =~ /_S\./ && (-s "$other~") > 10000) {
201 my $ncolor = 256;
202 while () {
203 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E";
204 system $OPTIPNG, "-i0", "-q", "$other~~";
205 last if 10000 > -s "$other~~";
206 $ncolor = int $ncolor * 0.9;
207 $ncolor > 8 or die "cannot reduce filesize to < 10000 bytes";
208 }
209
210 printf "reduced %s from %d to %d bytes using %d colours.\n",
211 $other, -s "$other~", -s "$other~~", $ncolor
212 if $VERBOSE >= 2;
213 rename "$other~~", "$other~";
214 }
215
216 die "$other~ has zero size, aborting." unless -s "$other~";
217 rename "$other~", $other;
218 };
219 }
220
221 #warn "scaled down $path to $other\n";#d#
222 push @png, [$other, !$CACHE];
223 }
224 }
225
226 (my $face = $stem) =~ s/^.*\///;
227
228 # split all bigfaces, but avoid smoothfaces (*_S)
132 if (($w > $T || $h > $T) && $face !~ /_S\./) { 229 if (($w > $T || $h > $T) && $face !~ /_S\./) {
133 # split 230 # split
134 my @tile; 231 my @tile;
135 for my $x (0 .. (int $w / $T) - 1) { 232 for my $x (0 .. (int $w / $T) - 1) {
136 for my $y (0 .. (int $h / $T) - 1) { 233 for my $y (0 .. (int $h / $T) - 1) {
149 (map { 246 (map {
150 ( 247 (
151 "(", 248 "(",
152 "+clone", 249 "+clone",
153 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T), 250 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T),
251 "+repage",
252 -quality => "00",
154 -write => "png:$_->[2]~", 253 -write => "png32:$_->[2]~",
155 "+delete", 254 "+delete",
156 ")", 255 ")",
157 ) 256 )
158 } @todo), 257 } @todo),
159 "null:"; 258 "null:";
163 close $convert; 262 close $convert;
164 263
165 # pass 2, optimise, and rename 264 # pass 2, optimise, and rename
166 for (@todo) { 265 for (@todo) {
167 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~"; 266 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~";
267 die "$_->[2]~ has zero size, aborting." unless -s "$_->[2]~";
168 rename "$_->[2]~", $_->[2]; 268 rename "$_->[2]~", $_->[2];
169 } 269 }
170 }; 270 };
171 } 271 }
172 272
176 276
177 if (0 > aio_load $file, $tile) { 277 if (0 > aio_load $file, $tile) {
178 die "$path: unable to read tile +$x+$y, aborting.\n"; 278 die "$path: unable to read tile +$x+$y, aborting.\n";
179 } 279 }
180 IO::AIO::aio_unlink $file unless $CACHE; 280 IO::AIO::aio_unlink $file unless $CACHE;
181 commit_png $x|$y ? "$face+$x+$y" : $face, $tile; 281 commit_png $x|$y ? "$face+$x+$y" : $face, $tile, $T;
182 } 282 }
183 } else { 283 } else {
184 # use as-is (either small, use smooth) 284 # use as-is (either small, use smooth)
185 commit_png $face, $png; 285 commit_png $face, $png, $T;
186 } 286 }
287
288 aio_unlink $path if $delete;
187 } 289 }
188 } 290 }
189 291
190 sub process_arc { 292 sub process_arc {
191 while (@arc) { 293 while (@arc) {
195 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/ 297 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/
196 298
197 my $arc = read_arch "$dir/$file"; 299 my $arc = read_arch "$dir/$file";
198 for my $o (values %$arc) { 300 for my $o (values %$arc) {
199 push @ARC, $o; 301 push @ARC, $o;
302 for (my $m = $o; $m; $m = $m->{more}) {
303 $ARC{$m->{_name}} = $m;
304 }
305
306 $o->{editor_folder} = $dir;
307
308 my $visibility = delete $o->{visibility};
309 my $magicmap = delete $o->{magicmap};
310
311 # find upper left corner :/
312 # omg, this is sooo broken
200 my ($dx, $dy); 313 my ($dx, $dy);
201 # omg, this is sooo broken
202 for (my $o = $o; $o; $o = $o->{more}) { 314 for (my $o = $o; $o; $o = $o->{more}) {
203 $dx = $o->{x} if $o->{x} < $dx; 315 $dx = $o->{x} if $o->{x} < $dx;
204 $dy = $o->{y} if $o->{y} < $dy; 316 $dy = $o->{y} if $o->{y} < $dy;
205 } 317 }
318
206 for (my $o = $o; $o; $o = $o->{more}) { 319 for (my $o = $o; $o; $o = $o->{more}) {
207 my $x = $o->{x} - $dx; 320 my $x = $o->{x} - $dx;
208 my $y = $o->{y} - $dy; 321 my $y = $o->{y} - $dy;
322
323 my $ext = $x|$y ? "+$x+$y" : "";
324
325 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face};
326
327 $visibility = delete $o->{visibility} if exists $o->{visibility};
328 $magicmap = delete $o->{magicmap} if exists $o->{magicmap};
329
330 my $anim = delete $o->{anim};
331
209 if ($x|$y) { 332 if ($anim) {
210 $_ .= "+$x+$y" for $o->{face}, @{$o->{anim} || []}; 333 # possibly add $ext to the animation name to avoid
334 # the need to specify archnames for all parts
335 # of a multipart archetype.
336 $o->{animation} = "$o->{_name}";
337 my $facings = 1;
338 my @frames;
339
340 for (@$anim) {
341 if (/^facings\s+(\d+)/) {
342 $facings = $1*1;
343 } elsif (/^blank.x11$|^empty.x11$/) {
344 push @frames, $_;
345 } else {
346 push @frames, "$_$ext";
347 }
348 }
349
350 $ANIMINFO{$o->{animation}} = {
351 facings => $facings,
352 frames => \@frames,
353 };
354 }
355
356 for my $face ($o->{face} || (), @{$anim || []}) {
357 next if $face =~ /^facings\s|^blank.x11$|^empty.x11$/;
358
359 my $info = $FACEINFO{$face} ||= {};
360
361 $info->{visibility} = $visibility if defined $visibility;
362 $info->{magicmap} = $magicmap if defined $magicmap;
363 }
364
365 if (my $smooth = delete $o->{smoothface}) {
366 my %kv =split /\s+/, $smooth;
367 my $level = $o->{smoothlevel}; #TODO: delete from $o if !gcfclient-support
368 while (my ($face, $smooth) = each %kv) {
369 $FACEINFO{$face}{smooth} = $smooth;
370 $FACEINFO{$face}{smoothlevel} = $level;
371 }
211 } 372 }
212 } 373 }
213 } 374 }
214 } 375 }
215 } 376 }
216 377
217 sub process_trs { 378 sub process_trs {
218 while (@trs) { 379 while (@trs) {
219 my ($dir, $file) = @{pop @trs}; 380 my ($dir, $file) = @{pop @trs};
381 my $path = "$dir/$file";
382
383 my $trs;
384 if (0 > aio_load $path, $trs) {
385 warn "$path: $!, skipping.\n";
386 next;
387 }
388
389 $TRS .= $trs;
390 }
391 }
392
393 my %FILECACHE;
394
395 sub load_cached($;$) {
396 unless (exists $FILECACHE{$_[0]}) {
397 my $data;
398 if (0 < aio_load $_[0], $data) {
399 $data = $_[1]->($data)
400 if $_[1];
401 }
402
403 $FILECACHE{$_[0]} = $data;
404 }
405
406 $FILECACHE{$_[0]}
407 }
408
409 sub process_res {
410 while (@res) {
411 my ($dir, $file, $type) = @{pop @res};
412
413 my $data;
414 aio_load "$dir/$file", $data;
415
416 my $meta = load_cached "$dir/meta", sub { JSON::XS::from_json shift };
417
418 $file =~ s/\.res$//;
419 $file =~ /\.(ogg|wav|jpg|png)$/;
420
421 substr $dir, 0, 1 + length $PATH, "";
422
423 $meta = {
424 %{ $meta->{"" } || {} },
425 %{ $meta->{$file} || {} },
426 };
427
428 $RESOURCE{"$dir/$file"} = {
429 type => (delete $meta->{type}) || $type,
430 data => $data,
431 chksum => (Digest::MD5::md5 $data),
432 %$meta ? (meta => $meta) : (),
433 };
220 } 434 }
221 } 435 }
222 436
223 sub find_files; 437 sub find_files;
224 sub find_files { 438 sub find_files {
229 my ($dirs, $nondirs) = @_; 443 my ($dirs, $nondirs) = @_;
230 444
231 find_files "$path/$_" 445 find_files "$path/$_"
232 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs; 446 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs;
233 447
448 my $dir = $path;
449 substr $dir, 0, 1 + length $PATH, "";
450
234 for my $file (@$nondirs) { 451 for my $file (@$nondirs) {
452 if ($dir =~ /^music(?:\/|$)/) {
453 push @res, [$path, $file, 3] # FT_MUSIC
454 if $file =~ /\.(ogg)$/;
455
456 } elsif ($dir =~ /^sounds(?:\/|$)/) {
457 push @res, [$path, $file, 5] # FT_SOUND
458 if $file =~ /\.(wav|ogg)$/;
459
460 } elsif ($dir =~ /^res(?:\/|$)/) {
461 push @res, [$path, $file, 0] # FT_FACE
462 if $file =~ /\.(jpg|png)$/;
463 push @res, [$path, $file, 7] # FT_RSRC
464 if $file =~ /\.(res)$/;
465
235 if ($file =~ /\.png$/) { 466 } elsif ($file =~ /\.png$/) {
236 push @png, "$path/$file"; 467 push @png, ["$path/$file", 0];
468
237 } elsif ($file =~ /\.trs$/) { 469 } elsif ($file =~ /\.trs$/) {
238 push @trs, [$path, $file]; 470 push @trs, [$path, $file];
471
239 } elsif ($file =~ /\.arc$/) { 472 } elsif ($file =~ /\.arc$/) {
240 push @arc, [$path, $file]; 473 push @arc, [$path, $file];
474
241 } else { 475 } else {
242 warn "ignoring $path/$file\n" if $VERBOSE >= 2; 476 warn "ignoring $path/$file\n" if $VERBOSE >= 3;
243 } 477 }
244 } 478 }
245 }; 479 };
246 } 480 }
247 481
248 sub inst_arch($) { 482 sub inst_arch($) {
249 my (undef, $path) = @_; 483 my (undef, $path) = @_;
250 484
485 $PATH = $path;
486
487 print "\n",
251 print "installing '$path' to '$DATADIR'\n\n"; 488 "Installing '$path' to '$DATADIR'\n",
489 "\n",
490 "This can take a long time if you run this\n",
491 "for the first time or do not use --cache.\n",
492 "\n",
493 "Unless you run verbosely, all following warning\n",
494 "or error messages indicate serious problems.\n",
495 "\n";
252 496
253 if (!-d "$path/treasures") { 497 if (!-d "$path/treasures") {
254 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n"; 498 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n";
255 exit 1 unless $FORCE; 499 exit 1 unless $FORCE;
256 } 500 }
257 501
258 find_files $path; 502 find_files $path;
259 IO::AIO::flush; 503 IO::AIO::flush;
260 504
261 $_->join for ( 505 $_->join for (
262 (async \&process_png), (async \&process_png), 506 # four png crunchers work fine for my 2x smp machine
507 (async \&process_png), (async \&process_png), (async \&process_png), (async \&process_png),
263 (async \&process_trs), (async \&process_trs), 508 (async \&process_trs), (async \&process_trs),
264 (async \&process_arc), (async \&process_arc), 509 (async \&process_arc), (async \&process_arc),
510 (async \&process_res), (async \&process_res),
265 ); 511 );
266 512
513 {
514 # remove path prefix from editor_folder
515 substr $_->{editor_folder}, 0, 1 + length $path, ""
516 for values %ARC;
517
518 # resolve inherit
519 while () {
520 my $progress;
521 my $loop;
522
523 for my $o (values %ARC) {
524 if (my $other = $o->{inherit}) {
525 if (my $s = $ARC{$other}) {
526 if ($s->{inherit}) {
527 $loop = $s;
528 } else {
529 delete $o->{inherit};
530 my %s = %$s;
531 delete @s{qw(_name more name name_pl)};
532 %$o = ( %s, %$o );
533 ++$progress;
534 }
535 } else {
536 warn "'$o->{_name}' tries to inherit from undefined archetype '$other', skipping.\n";
537 delete $ARC{$o->{_name}};
538 }
539 }
540 }
541
542 unless ($progress) {
543 die "inheritance loop detected starting at archetype '$loop->{_name}', aborting.\n"
544 if $loop;
545
546 last;
547 }
548 }
549
550 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit
551 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC;
552
267 open my $archetypes, ">:utf8", "$DATADIR/archetypes~" 553 open my $fh, ">:utf8", "$DATADIR/archetypes~"
268 or die "$DATADIR/archetypes~: $!"; 554 or die "$DATADIR/archetypes~: $!";
269 print $archetypes Crossfire::archlist_to_string \@ARC; 555 print $fh Crossfire::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC];
270 close $archetypes; 556 }
271 rename "$DATADIR/archetypes~", "$DATADIR/archetypes";
272 557
273 die "--install-arch not fully implemented\n"; 558 {
559 open my $fh, ">:utf8", "$DATADIR/treasures~"
560 or die "$DATADIR/treasures~: $!";
561 print $fh $TRS;
562 }
563
564 {
565 while (my ($k, $v) = each %FACEINFO) {
566 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n";
567 length $v->{data64} or warn "$k: face has no png64. this will not work very well.\n";
568
569 length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n";
570 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n";
571
572 $v->{chksum32} = Digest::MD5::md5 $v->{data32};
573 $v->{chksum64} = Digest::MD5::md5 $v->{data64};
574
575 if (my $magicmap = $v->{magicmap}) {
576 $magicmap =~ y/A-Z_\-/a-z/d;
577 $v->{magicmap} = $COLOR{$magicmap};
578 }
579 }
580
581 open my $fh, ">:perlio", "$DATADIR/facedata~"
582 or die "$DATADIR/facedata~: $!";
583
584 print $fh freeze {
585 version => 2,
586 faceinfo => \%FACEINFO,
587 animinfo => \%ANIMINFO,
588 resource => \%RESOURCE,
589 };
590 }
591
592 for (qw(archetypes facedata treasures)) {
593 chmod 0644, "$DATADIR/$_~";
594 rename "$DATADIR/$_~", "$DATADIR/$_"
595 or die "$DATADIR/$_: $!";
596 }
597
598 print "archetype data installed successfully.\n";
274 } 599 }
275} 600}
276 601
277Getopt::Long::Configure ("bundling", "no_ignore_case"); 602Getopt::Long::Configure ("bundling", "no_ignore_case");
278GetOptions ( 603GetOptions (

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines